package summa;

/**
 * <p>Title: Lukija </p>
 * <p>Description: lukee dataa |-erotetusta sytteest</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author Miika Nurminen
 * @version 1.0 / 2004-8-24
 */

import java.util.ArrayList;
import java.util.StringTokenizer;
import java.util.Iterator;

public class Lukija implements Filter {
  // sislt taulukon, jonka elementtej ovat dynaamiset taulukot
  private java.util.ArrayList content = new java.util.ArrayList();
  private int fieldNum;

  public Lukija(int fieldNum) {
    this.fieldNum = fieldNum;
  }

  public String processLine(String s) {
    StringTokenizer t = new java.util.StringTokenizer(s,"|");
    if (!t.hasMoreTokens()) return null;
    java.util.ArrayList a = new java.util.ArrayList();
    while (t.hasMoreTokens()) {
      String next = t.nextToken();
      a.add(next);
    }
    content.add(a);
    return null;
  }

  public String getResult() {
    sortByField(fieldNum);
    return toString();
  }

  /**
   * jrjest taulukon n:nnen kentn mukaan. huom. ei turvallinen
   * (ei rajatarkastuksia) - lisksi tietoja luettaessa kenttien mr
   * voi vaihdella.
   * @param num monennenko kentn mukaan jrjestetn
   */
  public void sortByField(final int num) {
    java.util.Collections.sort(content,new java.util.Comparator() {
      public int compare(Object object, Object object1) {
        if (!((object instanceof ArrayList) || (object1 instanceof ArrayList)))
          throw new ClassCastException();
        ArrayList a = (ArrayList)object;
        ArrayList b = (ArrayList)object1;
        return ((Comparable)a.get(num)).compareTo(b.get(num));
      }

      public boolean equals(Object object) {
        return false;
      }
    });
  }

  /**
   * summaa n:nnen kentn. huom, oletuksena on, ett kentt sislt
   * numerotietoa. ei rajatarkistuksia!
   * @param num
   * @return
   */
  public int sumByField(int num) {
    Iterator i = content.iterator();
    int result = 0;
    while (i.hasNext()) {
      ArrayList a  = ((ArrayList)i.next());
      String s = ((String)a.get(num));
      try {
        result += Integer.parseInt(s);
      }
      catch (NumberFormatException n) {
        System.err.println(n.getMessage());
        n.printStackTrace();
      }
    }
    return result;
  }

  /**
   * Overridetaan ylluokan toString
   * @return
   */
  public String toString() {
    Iterator i = content.iterator();
    StringBuffer sb = new StringBuffer(); // StringBuffer == mutable string
    while (i.hasNext()) {
      Object o = i.next();
      sb.append(o.toString());
      sb.append('\n');
    }
    return sb.toString();
  }
}