package summa;

/**
 * <p>Title: StreamSystem </p>
 * <p>Description: Esimerkki tietovirtojen kytst ja filttereist</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author Miika Nurminen
 * @version 1.0 / 2004-8-24
 *
 */

import java.io.*;

public class StreamSystem {

  private java.io.BufferedReader in;
  private java.io.PrintStream out;
  private Filter action;

  public StreamSystem(java.io.InputStream in, java.io.OutputStream out, Filter action) {
    // bufferedReader-luokan avulla voi lukea rivi kerrallaan
    this.in =  new BufferedReader(new InputStreamReader(in));
    this.out =  new PrintStream(out);
    this.action = action;
  }

  /**
   * Lukee sytevirtaa loppuun tai tyhjn riviin asti
   */
  public void getAll() {
    String s;
    String t;
    try {
      while (true) {
        s = in.readLine();
        if ((s==null) || (s.equals(""))) break;
        if (action==null) continue;
        t = action.processLine(s);
        if (t!=null) out.println(t);
      }
      t = action.getResult();
      if (t!=null) out.println(t);
    }
    catch (IOException e) {
      System.err.println(e.getMessage());
      e.printStackTrace();
    }
  }

  public static void main(String[] args) {
    try {
      EchoFilter e = new EchoFilter();
      Summaaja s = new Summaaja();
      Lukija luk = new Lukija(0);
      StreamSystem stream;
      FileInputStream fin;

      // 'dummy'-kaiutin
//    stream = new StreamSystem(System.in,System.out,e);

      // kaiutus tiedostoon
//    stream = new StreamSystem(System.in, new FileOutputStream("testi.txt"),e);

     // numerokysely
//     stream = new StreamSystem(System.in,System.out,s);

     // numerokysely tiedostosta
//     stream = new StreamSystem(new FileInputStream("input.txt"),System.out,s);

// kenttlukija
     fin = new FileInputStream("fields.txt");
      stream = new StreamSystem(fin,System.out,luk);

      stream.getAll();

      // suljetaan virta kytn jlkeen
      fin.close();

// vaihdetaan jrjestettv kentt
      luk.sortByField(1);
      System.out.println(luk.toString());

      // summaus
      System.out.println(luk.sumByField(2));

    }
    catch (Exception e) { // huono pikaratkaisu kaikkien poikkeusten ksittelyyn...
      System.err.println(e.getMessage());
      e.printStackTrace();
    }
  }

}